<!DOCTYPE HTML>
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>JSON-RPC Demo for JQuery Terminal Emulator</title>
    <meta name="author" content="Jakub Jankiewicz - jcubic&#64;onet.pl"/>
    <meta name="Description" content="Demonstration for JQuery Terminal Emulator using call automaticly JSON-RPC service (in php) with authentication."/>
    <link rel="sitemap" type="application/xml" title="Sitemap" href=""/>
    <link rel="stylesheet" href="default.min.css">
	<script src="highlight.pack.js"></script>
    <script src="common.js"></script>
    <link rel="shortcut icon" href="favicon.ico"/>
    <script src="jquery-1.7.1.min.js"></script>
    <script src="d3.min.js"></script>
    <script src="plotly.min.js"></script>
    <script src="jquery.mousewheel-min.js"></script>	
    <script src="jquery.terminal-0.9.3.min.js"></script>
    <link href="jquery.terminal-0.9.3.css" rel="stylesheet"/>
    <script src="requirejs/require.js"></script>
    <script src="faces_vis.js"></script>
  </head>
<body>
<script>
var lastsession
var lastcommand

var refocus = function () {$('html, body').animate({
										scrollTop: $("#term_demo").offset().top
									}, 300); }
function _checksession(session,cb)
{
	if(session instanceof Array)
	{
		var p0,lp0;
		for(var i = 0; i < session.length; i++)
		{
			lastsession = session[i]
			var q = cb(session[i])
			if(!p0)
				p0 = q;
			else
				lp0.then(q)
			lp0 = q;
		}
		return p0 // multiple promises in chain
	}
	else if(session)
	{
		lastsession = session	
		return cb(session) // promise
	}
	else if(!lastsession)
	{
		return "No session specified";
	}
}

function getMaxOfArray(numArray) {
  return Math.max.apply(null, numArray);
};

function getMinOfArray(numArray) {
  return Math.min.apply(null, numArray);
};

function _hands3d(session)
{
	var q = document.createElement("div")
	document.getElementById('content').appendChild(q)

	pelars.getData(session,"hand",function (r)
	{
		var xx = []
		var yy = []
		var zz = []
		for(var x = 0; x  < r.length; x++)
		{
			var xp = r[x]["tx"]*1000
			var yp  = r[x]["ty"]*1000
			var zp = r[x]["tz"]*1000
			xx.push(xp)
			yy.push(yp)
			zz.push(zp)
		}

		var hm = {
			x: xx,
			y:yy,
			z:zz,
			mode: 'markers',
			  marker: {
			    color: 'rgb(127, 127, 127)',
			    size: 2,
			    symbol: 'circle',
			    line: {
			      color: 'rgb(204, 204, 204)',
			      width: 1
			    },
			    opacity: 0.9
			  },
			  type: 'scatter3d'		
		};


		var data = [hm];
		
		Plotly.newPlot(q, data);
		refocus()

	})
}

function hands3d(session)
{
	_checksession(session,_hands3d)
}

function _handmotion(session)
{
	var q = document.createElement("div")
	document.getElementById('content').appendChild(q)

	pelars.getData(session,"hand",function (r)
	{
		var xstep = 20
		var ystep = 20
		var xrange = 1500.0
		var yrange = 1500.0
		var xdiv = xrange/xstep
		var ydiv = yrange/ystep
		var qq = []
		var xx = []
		var yy = []
		for(var i = 0; i < xstep; i++)
		{
			var l = []
			for (var j = 0; j < ystep; j++)
				l.push(0)
			qq.push(l)
		}
		for(var x = 0; x  < r.length; x++)
		{
			var xp = r[x]["tx"]*1000
			var yp  = r[x]["ty"]*1000
			xx.push(xp)
			yy.push(yp)
			var dx = Math.floor((xp+1100)/xdiv)
			var dy = Math.floor((yp+850)/ydiv)
			if(dx >= 0 & dx < xstep && dy >= 0 && dy < ystep)
			{
				qq[dy][dx] += 1
			}
		}
		console.log("span",getMinOfArray(xx),getMaxOfArray(xx),getMinOfArray(yy),getMaxOfArray(yy))

		var hm = {
		  z: qq,
		  type: 'heatmap',
		  colorscale: 'Viridis'
		};

		var axisTemplate = {
		  range: [0, 1.6],
		  autorange: false,
		  showgrid: false,
		  zeroline: false,
		  linecolor: 'black',
		  showticklabels: false,
		  ticks: ''
		};

		var data = [hm];
		
		Plotly.newPlot(q, data);
		refocus()

	})
}

function handmotion(session)
{
	_checksession(session,_handmotion)
}


function _presence(session)
{
	var q = document.createElement("div")
	document.getElementById('content').appendChild(q)

	pelars.getOpResult(session,"presence",function (r)
	{
		var qx = [];
		var qy = [];
		console.log(r)
		var t0 = r[0]["start"];
		for(var x = 0; x  < r.length; x++)
		{
			qx.push((r[x]["start"]-t0)/1000.0)
			qy.push(r[x]["presence"]?1:0)
		}
		var data = { "x":qx,"y":qy,"name":"Presence by time","type":"scatter"}
		Plotly.newPlot(q, [data])
	refocus()

	})
}

function presence(session)
{
	_checksession(session,_presence)
}

function datacard(session)
{
	return _checksession(session,_datacard)
}

function _datacard(session)
{
	var q = document.createElement("div")
	document.getElementById('content').appendChild(q)
	var s = '/dataCard/wholeCard.html?session=' + session+"&base="+pelars_base()
	$(q).html("<iframe src='"+s+"'><iframe>");
}

function _appendhtml(t,tag)
{
	var q = document.createElement(!tag ? "div" : tag);
	q.innerHTML =  t
	document.getElementById('content').appendChild(q)
	refocus()
}

function _appendjson(t)
{
	var q = document.createElement("pre");
	q.innerHTML =  "<code class=\"json\">"+JSON.stringify(t,null,2)+"</code>"
	document.getElementById('content').appendChild(q)
	hljs.highlightBlock(q)
	refocus()
}

var plots = {
	"hands": 
	{
		"facevis([session])" : "face count along time as in DataCard",
		"datacard([session])" : "full DataCard",
		"handmotion([session])": "heat map of hand motion",
		"hands3d([session])": "hands motion in 3D"
	}
}

/// configure for local
function offline()
{
	sessionStorage.setItem("baseurl","http://127.0.0.1:8002")
}

function online()
{
	sessionStorage.setItem("baseurl","")
}

function facevis(session)
{
	return _checksession(session,_facevis)
}

function _facevis(session)
{
	return new Promise(
		function (fullfill,reject)
		{
			if(!lastsession)
			{
				console.log("no active session")
				reject()
				return;
			}
			
			{
				console.log("using faces_vis")
				var q = document.createElement("div");
				document.getElementById('content').appendChild(q)
				faces_vis.create(q,lastsession,pelars);
				fullfill()
			}
		}
		)
}

function clear()
{
	$("#content").empty()
}

function releaseToken()
{
	sessionStorage.setItem("token",null)
}

function authenticate()
{
	pelars.authenticate(function () {})
}

function getSession(id)
{
	return new Promise(
		function (fullfill,reject)
		{
			lastsession = undefined
			pelars.getSession(id,function(data,session_id) 
				{
					lastsession = session_id
					_appendjson(data)
					fullfill()
				}
			)
		}
		)
}

function help()
{
	// array being ordered
	var commands = [
		["help()","This help"],
		["clear()","Clears the console"],
		["authenticate()","Verifies authentication"],
		["releaseToken()","Releases token"],

		["offline()","Switches to the local server"],
		["online()","Switches to the main server"]
	]

	var q = "<table>"
	for(var i = 0; i < commands.length; i++)
	{
		var c = commands[i];
		q += "<tr><td>" + c[0] + "</td><td>" + c[1] + "</td><td>"

	}
	for(var ft in plots)
	{
		for(var name in plots[ft])
		{
			var d = plots[ft][name]
			q += "<tr><td>" + ft + " - " + name + "</td><td>" + d + "</td><td>"
		}

	}
	q += "</table>"
	_appendhtml(q)
}
jQuery(function($, undefined) {
	window.onload = function() {	

			pelars.authenticate(function done()
					{
						$('#term_demo').terminal(
								function(command, term) {
							        if (command !== '') {
							            try {
							            	lastcommand = command
							                _appendhtml("> " + command)
							                var result = window.eval(command);
							                if(result instanceof Promise)
							                	result = Promise.resolve(result);
							                if (typeof(result) !== "object" && typeof(result) !== "undefined") {
							                    term.echo(new String(result));
							                }
							            } catch(e) {
							                term.error(new String(e));
							            }
							        } else {
							           term.echo('');
							        }
				    			}, 
				    			{
							        greetings: 'PELARS REPL',
							        name: 'js_demo',
							        height: 20,
							        prompt: 'js> '}
							    )

					}
				)


		};

});
</script>
<div id="content">
</div>
<div id="term_demo">
</div>
